AbstractFuture
Date: 2016-05-24

com.google.common.util.concurrent

## Class AbstractFuture<V>

- java.lang.Object
- - com.google.common.util.concurrent.AbstractFuture<V>

- All Implemented Interfaces:
    ListenableFuture<V>, java.util.concurrent.Future<V>
  Direct Known Subclasses:
    SettableFuture

      @GwtCompatible(emulated=true)
      public abstract class AbstractFuture<V>
      extends java.lang.Object
      implements ListenableFuture<V>

  An abstract implementation of `ListenableFuture`, intended for advanced users only. More common ways to create a `ListenableFuture` include instantiating a `SettableFuture`, submitting a task to a `ListeningExecutorService`, and deriving a `Future` from an existing one, typically using methods like `Futures.transform` and `Futures.catching`.

  This class implements all methods in `ListenableFuture`. Subclasses should provide a way to set the result of the computation through the protected methods `set(Object)`, `setFuture(ListenableFuture)` and `setException(Throwable)`. Subclasses may also override `interruptTask()`, which will be invoked automatically if a call to `cancel(true)` succeeds in canceling the future. Subclasses should rarely override other methods.

  Since:
    1.0

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractFuture()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(java.lang.Runnable listener, java.util.concurrent.Executor executor)` Registers a listener to be run on the given executor.
    `boolean` | `cancel(boolean mayInterruptIfRunning)`
    `V` | `get()`
    `V` | `get(long timeout, java.util.concurrent.TimeUnit unit)`
    `protected void` | `interruptTask()` Subclasses can override this method to implement interruption of the future's computation.
    `boolean` | `isCancelled()`
    `boolean` | `isDone()`
    `protected boolean` | `set(V value)` Sets the result of this `Future` unless this `Future` has already been cancelled or set (including set asynchronously).
    `protected boolean` | `setException(java.lang.Throwable throwable)` Sets the failed result of this `Future` unless this `Future` has already been cancelled or set (including set asynchronously).
    `protected boolean` | `setFuture(ListenableFuture<? extends V> future)` Sets the result of this `Future` to match the supplied input `Future` once the supplied `Future` is done, unless this `Future` has already been cancelled or set (including "set asynchronously," defined below).
    `protected boolean` | `wasInterrupted()` Returns true if this future was cancelled with `mayInterruptIfRunning` set to `true`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractFuture

          protected AbstractFuture()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### get

          public V get(long timeout,
              java.util.concurrent.TimeUnit unit)
                throws java.lang.InterruptedException,
                       java.util.concurrent.TimeoutException,
                       java.util.concurrent.ExecutionException

      The default `AbstractFuture` implementation throws `InterruptedException` if the current thread is interrupted before or during the call, even if the value is already available.

      Specified by:
        `get` in interface `java.util.concurrent.Future<V>`
      Throws:
        `java.lang.InterruptedException` - if the current thread was interrupted before or during the call (optional but recommended).
        `java.util.concurrent.CancellationException`
        `java.util.concurrent.TimeoutException`
        `java.util.concurrent.ExecutionException`

    - #### get

          public V get()
                throws java.lang.InterruptedException,
                       java.util.concurrent.ExecutionException

      The default `AbstractFuture` implementation throws `InterruptedException` if the current thread is interrupted before or during the call, even if the value is already available.

      Specified by:
        `get` in interface `java.util.concurrent.Future<V>`
      Throws:
        `java.lang.InterruptedException` - if the current thread was interrupted before or during the call (optional but recommended).
        `java.util.concurrent.CancellationException`
        `java.util.concurrent.ExecutionException`

    - #### isDone

          public boolean isDone()

      Specified by:
        `isDone` in interface `java.util.concurrent.Future<V>`

    - #### isCancelled

          public boolean isCancelled()

      Specified by:
        `isCancelled` in interface `java.util.concurrent.Future<V>`

    - #### cancel

          public boolean cancel(boolean mayInterruptIfRunning)

      If a cancellation attempt succeeds on a `Future` that had previously been set asynchronously, then the cancellation will also be propagated to the delegate `Future` that was supplied in the `setFuture` call.

      Specified by:
        `cancel` in interface `java.util.concurrent.Future<V>`

    - #### interruptTask

          protected void interruptTask()

      Subclasses can override this method to implement interruption of the future's computation. The method is invoked automatically by a successful call to `cancel(true)`.

      The default implementation does nothing.

      Since:
        10.0

    - #### wasInterrupted

          protected final boolean wasInterrupted()

      Returns true if this future was cancelled with `mayInterruptIfRunning` set to `true`.
      Since:
        14.0

    - #### addListener

          public void addListener(java.lang.Runnable listener,
                         java.util.concurrent.Executor executor)

      Registers a listener to be run on the given executor. The listener will run when the `Future`'s computation is complete or, if the computation is already complete, immediately.

      There is no guaranteed ordering of execution of listeners, but any listener added through this method is guaranteed to be called once the computation is complete.

      Exceptions thrown by a listener will be propagated up to the executor. Any exception thrown during `Executor.execute` (e.g., a `RejectedExecutionException` or an exception thrown by direct execution) will be caught and logged.

      Note: For fast, lightweight listeners that would be safe to execute in any thread, consider `MoreExecutors.directExecutor()`. Otherwise, avoid it. Heavyweight `directExecutor` listeners can cause problems, and these problems can be difficult to reproduce because they depend on timing. For example:

      - The listener may be executed by the caller of `addListener`. That caller may be a UI thread or other latency-sensitive thread. This can harm UI responsiveness.
      - The listener may be executed by the thread that completes this `Future`. That thread may be an internal system thread such as an RPC network thread. Blocking that thread may stall progress of the whole system. It may even cause a deadlock.
      - The listener may delay other listeners, even listeners that are not themselves `directExecutor` listeners.

      This is the most general listener interface. For common operations performed using listeners, see `Futures`. For a simplified but general listener interface, see `addCallback()`.

      Memory consistency effects: Actions in a thread prior to adding a listener happen-before its execution begins, perhaps in another thread.

      Specified by:
        `addListener` in interface `ListenableFuture<V>`
      Parameters:
        `listener` - the listener to run when the computation is complete
        `executor` - the executor to run the listener in
      Since:
        10.0

    - #### set

          protected boolean set(@Nullable
                    V value)

      Sets the result of this `Future` unless this `Future` has already been cancelled or set (including set asynchronously). When a call to this method returns, the `Future` is guaranteed to be done only if the call was accepted (in which case it returns `true`). If it returns `false`, the `Future` may have previously been set asynchronously, in which case its result may not be known yet. That result, though not yet known, cannot by overridden by a call to a `set*` method, only by a call to `cancel(boolean)`.
      Parameters:
        `value` - the value to be used as the result
      Returns:
        true if the attempt was accepted, completing the `Future`

    - #### setException

          protected boolean setException(java.lang.Throwable throwable)

      Sets the failed result of this `Future` unless this `Future` has already been cancelled or set (including set asynchronously). When a call to this method returns, the `Future` is guaranteed to be done only if the call was accepted (in which case it returns `true`). If it returns `false`, the `Future` may have previously been set asynchronously, in which case its result may not be known yet. That result, though not yet known, cannot by overridden by a call to a `set*` method, only by a call to `cancel(boolean)`.
      Parameters:
        `throwable` - the exception to be used as the failed result
      Returns:
        true if the attempt was accepted, completing the `Future`

    - #### setFuture

          @Beta
          protected boolean setFuture(ListenableFuture<? extends V> future)

      Sets the result of this `Future` to match the supplied input `Future` once the supplied `Future` is done, unless this `Future` has already been cancelled or set (including "set asynchronously," defined below).

      If the supplied future is done when this method is called and the call is accepted, then this future is guaranteed to have been completed with the supplied future by the time this method returns. If the supplied future is not done and the call is accepted, then the future will be set asynchronously. Note that such a result, though not yet known, cannot by overridden by a call to a `set*` method, only by a call to `cancel(boolean)`.

      If the call `setFuture(delegate)` is accepted and this `Future` is later cancelled, cancellation will be propagated to `delegate`. Additionally, any call to `setFuture` after any cancellation will propagate cancellation to the supplied `Future`.

      Parameters:
        `future` - the future to delegate to
      Returns:
        true if the attempt was accepted, indicating that the `Future` was not previously cancelled or set.
      Since:
        19.0